#include <stdio.h>
#include <stdlib.h>

#include "f2c.h"

int main(void)
{
    /* Builtin functions */
    double cos(double), sin(double);

    /* Local variables */
    extern int f_c();
    static double h__;
    static int k, m, n;
    static double q, y[2], h0, ay[26] /* was [2][13] */, xk, xn, yn[2];
    static int nx;
    static double xs[5], yt[2];
    static double rab[396], ady[24]	/* was [2][12] */;
    extern int de55d_c( );
    static double dely[2];
    static int imax, iordy, iniapr;

    m = 2;
    q = .5;
    xn = 0.f;
    yn[0] = cos(q) + 1.;
    yn[1] = -sin(q) + 1.;
    xk = 1.;
    iordy = 1;
    h0 = 1.;
    yt[0] = cos(q * (xk * 2. - 1.)) + 1.;
    yt[1] = sin(q * (xk * 2. - 1.)) + 1.;
    k = 11;
    imax = 16;
    iniapr = 1;
    h__ = h0;
    de55d_c((U_fp)f_c, &m, &xn, yn, &xk, &k, &iniapr, &imax, &iordy, &h__, y,
            &nx, xs, ay, ady, rab);
    dely[0] = yt[0] - y[0];
    dely[1] = yt[1] - y[1];

    printf("\n nx=%3i xs[0]= %21.14e xs[1]=%21.14e\n", nx,xs[0],xs[1]);

    printf("\n h0=%21.14e k=%3i iniapr= %1i imax=%3i iordy=%3i\n",h0,k,iniapr,imax,iordy);
    printf("\n y[0]= %21.14e y[1]=%21.14e\n",y[0],y[1]);
    printf("\n yt[0]=%21.14e y[1]= %21.14e\n",yt[0],yt[1]);
    printf("\n dely");
    printf("\n %23.14e %23.14e \n", dely[0], dely[1]);

    printf("\n\n      COEFFICIENTS AY AND ADY ON 1 SEGMENT \n");
    printf("\n      Chebyshev coefficients for 1 component\n");
    printf("\n           for Y                   for  Y' \n");

    for (n = 0; n <= 23;  n+=2) {
         printf("\n %3i %23.14e %23.14e ", n/2, ay[n], ady[n]);
    }
    printf("\n %3i %23.14e \n", n/2, ay[24]);

    printf("\n      Chebyshev coefficients for 2 component\n");
    printf("\n           for Y                   for  Y' \n");
    for (n = 1; n <= 23;  n+=2) {
         printf("\n %3i %23.14e %23.14e ", n/2, ay[n], ady[n]);
    }
    printf("\n %3i %23.14e \n", n/2, ay[25]);

    return 0;
} /* main */


 int f_c(double *x, double *y, double *z__, int *m)
{
    /* Builtin functions */
    double cos(double), exp(double), sin(double);

    /* Local variables */
    static double q, r__;

    /* Parameter adjustments */
    --z__;
    --y;

    /* Function Body */
    q = .5;
    r__ = *x * 2. - 1.;
    z__[1] = q * -2. * (y[2] - 1.) + (1. - exp(1. - y[1] + cos(q * r__))) /
            (*x + 1.);
    z__[2] = q * 2. * (y[1] - 1.) + (1. - exp(1. - y[2] + sin(q * r__))) /
            (*x + 1.);
    return 0;
} /* f_c */
